//+------------------------------------------------------------------+
//|                       -modified (-of FXBootcamp) WyattsPivots.mq4|
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers   0

extern ENUM_TIMEFRAMES  TimePeriod=PERIOD_H4;
int              CountPeriods=1;
bool             PlotPivots=true;
bool             PlotFuturePivots=true;
bool             PlotPivotLabels=false;
int              WidthPivots=1;
color            ColorPivPref;
ENUM_LINE_STYLE  StylePivots=STYLE_SOLID;

string   period;

datetime timestart,timeend;
double   close,high,low,PP,R1,S1,stPivPref;
int      shift; 
     
void LevelsDelete(string name)
{
   ObjectDelete("stPivPref"+name);
}

bool PlotTrend(const long              chart_ID=0,
               string                  name="trendline",
               const int               subwindow=1,
               datetime                time1=0,
               double                  price1=0,
               datetime                time2=0,
               double                  price2=0,             
               const color             clr=clrDarkGreen,
               const ENUM_LINE_STYLE   style=STYLE_SOLID,
               const int               width=1,
               const bool              back=true,
               const bool              selection=false,
               const bool              ray=false,
               const bool              hidden=false)
{
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,subwindow,time1,price1,time2,price2))
   {
      Print(__FUNCTION__,": failed to create arrow = ",GetLastError());
      return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY,ray);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   return(true);
}

void LevelsDraw(  int      shft,
                  datetime tmestrt, 
                  datetime tmend, 
                  string   name,
                  bool     future)
{
   high  = iHigh(NULL,TimePeriod,shft);
   low   = iLow(NULL,TimePeriod,shft);
   if(future==false){close = iClose(NULL,TimePeriod,shft);}else{close = Bid;}      
     
   PP  = (high+low+close)/3.0;
   R1 = 2*PP-low;
   S1 = 2*PP-high;
   stPivPref = (1-((PP-S1)/(R1-PP)));         
   if(PlotPivots){                                 
      PlotTrend(0,"stPivPref"+name,1,tmestrt,stPivPref,tmend,stPivPref,ColorPivPref,StylePivots,WidthPivots);
                 }
}        
int init(){
   if(TimePeriod==PERIOD_M1||TimePeriod==PERIOD_CURRENT){TimePeriod=PERIOD_M5;period="M5";}
   if(TimePeriod==PERIOD_M5){period="M5";}
   if(TimePeriod==PERIOD_M15){period="M15";}
   if(TimePeriod==PERIOD_M30){period="M30";}
   if(TimePeriod==PERIOD_H1){period="H1";}
   if(TimePeriod==PERIOD_H4){period="H4";}
   if(TimePeriod==PERIOD_D1){period="D1";}
   if(TimePeriod==PERIOD_W1){period="W1";}
   if(TimePeriod==PERIOD_MN1){period="MN1";}  
   return(0);
}   
   
int deinit(){
   for(shift=0;shift<=CountPeriods;shift++){
      LevelsDelete(period+shift);
   }
   LevelsDelete("F"+period);
   Comment("");
   return(0);
}

int start(){
   if (TimePeriod==PERIOD_MN1){
   ColorPivPref = clrNONE;
   WidthPivots = 3;
   }
   if (TimePeriod==PERIOD_W1){
   ColorPivPref = clrNONE;
   WidthPivots = 2;
   }
   if (TimePeriod==PERIOD_D1){
   ColorPivPref = clrNONE;
   WidthPivots = 1;
   }
   
   for(shift=0;shift<=CountPeriods;shift++){
      LevelsDelete(period+shift);
   }
   LevelsDelete("F"+period);
   
   for(shift=CountPeriods-1;shift>=0;shift--){
      timestart = iTime(NULL,TimePeriod,shift);
      timeend   = iTime(NULL,TimePeriod,shift)+TimePeriod*60;   
      LevelsDraw(shift+1,timestart,timeend,period+shift,false);                
   }
   
   if(PlotFuturePivots){
      timestart=iTime(NULL,TimePeriod,0)+TimePeriod*60;
      timeend=iTime(NULL,TimePeriod,0)+TimePeriod*120;
      LevelsDraw(0,timestart,timeend,"F"+period,true);      
   }  
   return(0);
}